"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const operators_1 = require("rxjs/operators");
const plain_animator_1 = require("./plain-animator");
class PlainSingularAnimator extends plain_animator_1.PlainAnimator {
    constructor(texture, tilesAmountHorizontally, tilesAmountVertically, tilesTotalAmount, framesPerSecond) {
        super(texture, tilesAmountHorizontally, tilesAmountVertically, tilesTotalAmount, framesPerSecond);
    }
    play() {
        let requestId;
        const animation = () => {
            this.animate();
            requestId = requestAnimationFrame(animation);
        };
        requestId = requestAnimationFrame(animation);
        this.end$.pipe(operators_1.take(1)).toPromise().then(() => cancelAnimationFrame(requestId));
    }
    animate(timestamp) {
        this.currentFrameDisplayTime += this.clock.getDelta() * 1000;
        while (this.currentFrameDisplayTime > this.frameDisplayDuration) {
            this.currentFrameDisplayTime -= this.frameDisplayDuration;
            if (this.currentFrame < this.tilesTotalAmount) {
                this.currentFrame += 1;
            }
            this.updateTexture();
            if (this.currentFrame === this.tilesTotalAmount) {
                this.end$.next(true);
                return;
            }
        }
    }
}
exports.PlainSingularAnimator = PlainSingularAnimator;
